<template>
  <div>
    <el-page-header content="详情" style=" padding: 20px 20px 0 20px;" @back="handleBack" />
    <sales-header ref="header" />
    <sales-table :data-list="dataList" :column="column" @handleSelection="handleSelection">
      <!--      <template #bts>-->
      <!--        <div>-->
      <!--          <el-button type="primary" size="mini" @click="dialogVisible=true">添加</el-button>-->
      <!--          <el-button type="danger" size="mini" @click="delChange">删除</el-button>-->
      <!--        </div>-->
      <!--      </template>-->
      <template #events>
        <div v-if="details.status==1 || details.status==2">
          <el-button type="primary" size="mini" @click="handleInform(2)">通知发货</el-button>
          <el-button size="mini">撤销发货</el-button>
        </div>
        <div v-if="details.status==3">
          <el-button type="primary" size="mini" @click="handleInform(3)">发货</el-button>
          <el-button size="mini">撤销发货</el-button>
        </div>
        <div v-if="details.status==4">
          <el-button type="primary" size="mini" @click="handleInform(4)">签收</el-button>
        </div>
      </template>
      <template v-slot:custom="{item:{row,$index}}">
        <el-radio v-model="row.flag" label="1">增加</el-radio>
        <el-radio v-model="row.flag" label="-1">减少</el-radio>
      </template>
      <template v-slot:operation="{item:{row,$index}}">
        <el-popconfirm
          style="margin-left: 10px"
          title="删除？"
          @onConfirm="handleDel(row,$index)"
        >
          <el-button slot="reference" type="text" size="mini">删除</el-button>
        </el-popconfirm>
      </template>
    </sales-table>
    <LogisticsTabs />
    <sales-dialog
      :dialog-visible="dialogVisible"
      :customer-number="customerNumber"
      :func="getDialogList"
      @confirm="confirm"
    />
  </div>
</template>

<script>
import SalesDialog from '@/components/SalesDialog/SalesDialog'
import SalesHeader from '@/components/SalesHeader/SalesHeader'
import SalesTable from '@/components/SalesTable/SalesTable'
import { addFrontOrder, getFrontOrderDetail, sbumitFrontOrder } from '@/api/sales'
import { getcustomerFrontList } from '@/api/stock'
import LogisticsTabs from '@/components/LogisticsTabs'

export default {
  name: 'WarehouseForm',
  components: {
    SalesHeader,
    SalesTable,
    SalesDialog,
    LogisticsTabs
  },
  props: ['detailsId', 'pageType'],
  data() {
    return {
      dialogVisible: false,
      customerNumber: '',
      dataList: [],
      details: {},
      selection: [],
      flag: 1,
      column: [
        {
          prop: 'materialName',
          label: '产品名称',
          width: '180'
        },
        {
          prop: 'materialOldNumber',
          label: '物料编码',
          width: '180'
        },
        {
          prop: 'specification',
          label: '规格型号',
          width: '300'
        },
        {
          prop: 'stockLockQty',
          label: '库存数量',
          width: '180'
        },
        {
          prop: 'qty',
          label: '数量',
          width: '180'
        },
        {
          prop: 'volume',
          label: '体积',
          width: '180'
        },
        {
          prop: 'totalVolume',
          label: '总体积',
          width: '180'
        },
        {
          prop: 'notes',
          label: '备注',
          width: '180'

        }
      ],
      activities: [{
        content: '活动按期开始',
        color: '#0bbd87',
        timestamp: '2018-04-15'
      }, {
        content: '通过审核',
        timestamp: '2018-04-13'
      }, {
        content: '创建成功',
        timestamp: '2018-04-11'
      }]

    }
  },
  created() {
    if (this.detailsId) {
      getFrontOrderDetail({ id: this.detailsId }).then(res => {
        this.dataList = res.data.orders
        this.details = res.data
        this.$refs.header.screenForm = res.data
        this.$refs.header.screenForm.disabled = true

        this.$refs.header.screenForm.provinceId = res.data.province
        this.$refs.header.screenForm.cityId = res.data.city
        this.$refs.header.screenForm.areaId = res.data.area
        this.$refs.header.screenForm.streetId = res.data.street
        this.$refs.header.screenForm.stockType = res.data.stockType == 1 ? '前置仓' : '商家仓'
      })
    }
  },
  methods: {
    getDialogList(p) {
      return getcustomerFrontList(...p)
    },
    confirm(selected) {
      // console.log(selected)
      this.dataList = selected
      this.$refs.header.screenForm.customerName = this.dataList[0].customerName
      this.$refs.header.screenForm.customerNumber = this.dataList[0].customerNumber
      this.customerNumber = this.dataList[0].customerNumber
      this.dialogVisible = false
    },
    handleDel(item, index) {
      this.dataList.splice(index, 1)
    },
    delChange() {
      this.dataList.forEach((k, i) => {
        this.selection.forEach((l, e) => {
          if (k.id === l.id) {
            this.dataList.splice(i, 1)
            this.selection.splice(e, 1)
          }
        })
      })
    },
    handleSelection(data) {
      this.selection = data
    },
    handelSubmit() {
      this.dataList.forEach(k => {
        k.id = ''
        k.directFlag = k.flag
      })
      const params = {
        ...this.$refs.header.screenForm,
        orders: this.dataList
      }
      addFrontOrder(params).then(res => {
        this.$successMsg('新增成功')
        this.handleBack()
        this.$forceUpdate()
      })
    },
    handelSigning() {
      this.$confirm('请确定，订单产品客户已完成签收，一旦签收则不能撤销', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(res => {

      }).catch(err => {

      })
    },
    handleInform(status = 2) {
      sbumitFrontOrder({ id: this.$refs.header.screenForm.id, status }).then(res => {
        this.$successMsg('退货通知')
      })
    },
    handleBack() {
      this.$emit('close')
    }

  }
}
</script>

<style scoped>

</style>
